#
# Pre Patch Script for DA
#
#######################################
#
# 1. Stop the WebServer Instance
#
# 2. Take the backup of statefile.properties and IscliCfgDeafults.properties
#
#######################################

if (@ARGV != 2) {
	print "Incorrect no: of arguments\n";
	&Usage;
	exit(1);
}

&stopWS;
&backupPropFiles;


#######################################
#
# Usage
#
########################################
sub Usage
{
print <<USAGE;

Usage:
	prepatch.pl <WebServer-Root Path> <instance-name>
	
	WebServer-Root Path : Path where WebServer is being installed
	instance-name : The instance where DA is been deployed, without 'https-'
	
USAGE
}


#######################################
#
# Stop WebServer
#
#######################################
sub stopWS
{
	$StopWebServerCmd = "$ARGV[0]\\https-$ARGV[1]\\stopsvr.bat";
	system($StopWebServerCmd);
}


#######################################
#
# Backup two properties file
#
#######################################
sub backupPropFiles
{
	$DALibPath = "$ARGV[0]\\..\\DelegatedAdmin\\lib";
	system("copy \"$DALibPath\\IscliCfgDefaults.properties\" \"$DALibPath\\IscliCfgDefaults.properties.orig\"");
	system("copy \"$DALibPath\\statefile.properties\" \"$DALibPath\\statefile.properties.orig\"");
}
